﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        public MainWindow()
        {
            InitializeComponent();
           
        }
    }

    public class VM : INotifyPropertyChanged
    {
        ObservableCollection<Person> people;
        Object[] selectedPeople;

        public VM()
        {
            People = new ObservableCollection<Person>();


            People.Add(new Person() { Age = 60, Name = "John" });
            People.Add(new Person() { Age = 12, Name = "Brenda" });
            People.Add(new Person() { Age = 10, Name = "Tom" });
            People.Add(new Person() { Age = 12, Name = "Fred" });


        }

        public ObservableCollection<Person> People
        {
            get
            {
                return people;
            }
            set
            {
                if (value != people)
                {
                    people = value;
                    this.RaisePropertyChanged("People");
                }
            }
        }

        public Object[] SelectedPeople
        {
            get
            {
                return selectedPeople;
            }
            set
            {
                if (value != selectedPeople)
                {
                    selectedPeople = value;
                    this.RaisePropertyChanged("SelectedPeople");
                }
            }
        }
        
      


        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private string name;
        private int age;

        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    this.RaisePropertyChanged("Name");
                }
            }
        }

        public int Age
        {
            get
            {
                return this.age;
            }
            set
            {
                if (this.age != value)
                {
                    this.age = value;
                    this.RaisePropertyChanged("Age");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }


}
